<?php
class categories {

	private $all_categories = false;
	private $categories = array();
	private $tree_categories_b = false;
	private $tree_categories = array(); 
	
	public function __construct() {
		
		
	}
	
	public function getAll() {
		global $main;
		
		if (!$this->all_categories) {
			
			$db = $main->_class('db');
			$result = $db->query('SELECT `id`,`name`,`parent_id` FROM `categorys`');
			
			if ($result) {
				while ($row = $result->fetch_assoc()) {
						$this->categories[$row['id']] = array('name'=>$row['name'],'parent_id'=>$row['parent_id']);
				}
				$this->all_categories = true;
			} else {
				return false; 
			}
		}
		return $this->categories;
		
	}
	
	
	public function getTree() {
		
		if (!$this->tree_categories_b) {
			
			if (!$this->all_categories) {
				$this->getAll();
			} 
		
			$tree = array();
			$categories = $this->categories;
			foreach ($categories as $k => &$v) {
				
				if (!$v['parent_id']) {
					$tree[$k] = $v;
				} else {
					$categories[$v['parent_id']]['childs'][$k] =&$v;
				}
				
			}
			
			$this->tree_categories = $tree;
		
		}
		
		return $this->tree_categories; 
		
	}
	
	public function getBreadCrumbs($id) {
		
		$id = (int)$id;
		
		if ($this->all_categories) {
	
			if (!isset($this->categories[$id])) {
				return false;
			}
			
			return $this->getArrayCrumbs_r($id);
			
		} else {
			global $main;
			
			$result = $main->_class('db')->query('SELECT 1 FROM `categorys` WHERE `id`='.$id.' limit 1'); 
			
			if (!$result or !$result->num_rows) {
				return false;
			}
			
			return $this->getDbCrumbs_r($id);
		}
	
	}
	
	
	private function getArrayCrumbs_r($id) {
			
		if ($this->categories[$id]['parent_id']) { //134 
			$ar = $this->getArrayCrumbs_r($this->categories[$id]['parent_id']); //134,array(136=>'Android')
		} 
		$ar[$id] = $this->categories[$id]['name'];
		return $ar;
		
	}
	
	private function getDbCrumbs_r($id) {
		global $main;
		
		$result = $main->_class('db')->query('SELECT `id`,`name`,`parent_id` FROM `categorys` WHERE `id`='.$id.' limit 1'); 
		$row = $result->fetch_assoc();
		
		if ($row['parent_id']) { //134 
			$ar = $this->getDbCrumbs_r($row['parent_id']); 
		} 
		
		$ar[$id] = $row['name'];
		return $ar;
		
	}
	
	
	public function printTree() {
		
		if (!$this->tree_categories_b) {
			$this->getTree();
		}
		$this->printTree_r($this->tree_categories);
	}
	
	private function printTree_r($tree) {
		
		echo '<ul class="nav nav-list">';
		
			foreach ($tree as $k=>$v) {
				echo '<li><a href="?page=cat&id='.$k.'">'.$v['name'].'</a>';
				if (isset($v['childs'])) {
					$this->printTree_r($v['childs']);
				}
				echo '</li>';
			}
			
		echo '</ul>';
		
	}

}
?>