<?php
/*
function __autoload($class){
    require(ROOT_DIR . '/engine/classes/' . $class . '.php');
} 
*/
function print_message($title,$message) {
	ob_end_clean();
	require(ROOT_DIR . '/engine/message_template.php');
	exit;
}

function get_config($name) {
	return include(ROOT_DIR . '/engine/configs/' . $name . '.php');
}

function remove_invisible_characters($str, $url_encoded = TRUE) {
	$non_displayables = array();
	
	// every control character except newline (dec 10)
	// carriage return (dec 13), and horizontal tab (dec 09)
	
	if ($url_encoded) {
		$non_displayables[] = '/%0[0-8bcef]/';	// url encoded 00-08, 11, 12, 14, 15
		$non_displayables[] = '/%1[0-9a-f]/';	// url encoded 16-31
	}
	
	$non_displayables[] = '/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]+/S';	// 00-08, 11, 12, 14-31, 127

	do {
		$str = preg_replace($non_displayables, '', $str, -1, $count);
	} while ($count);

	return $str;
}