<?php
final class Main {
	
	private static $lib = array();
	private static $models = array();
	private static $controllers = array();
	
	private static function &load($classname, $dir, $type) {
		if(!isset(self::${$type}[$classname])) {
			include (ROOT_DIR . '/engine/' . $dir . '/' . $classname . '.php'); 

			self::${$type}[$classname] = new $classname;
		}
		return self::${$type}[$classname];
	}
	
	public static function &lib($classname) {
		return self::load($classname, 'classes', 'lib');
	}
	
	public static function &model($classname) {
		return self::load($classname . '_model', '../models', 'models');
	}
	
	public static function controller($classname) {
	echo ROOT_DIR . '/controllers/csv_controller.php';
		include (ROOT_DIR . '/controllers/csv_controller.php'); 
		$classname = 'csv_controller';
		return new $classname . '_controller';
	}	
}