<?php
final class View {
	
	private $view = 'pages';
	
	public function set($view) {
		$this->view = $view;
	}
	
	public function generate($template, $vars) {
		extract($vars, EXTR_SKIP);
		ob_start();
		include(TEMPLATE_DIR . '/views/' . $this->view . '/' . $template . '.php');
		return ob_get_clean();
	}
}