<!DOCTYPE html>
<html lang="en">
  <head>
    <base href="<?php echo BASE_URL; ?>">
	<meta charset="utf-8">
    <title><?php echo $title; ?></title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="">

	<link rel="shortcut icon" href="favicon.ico">
	
    <!-- Le styles -->
	<link href="<?php echo TEMPLATE_URL; ?>css/bootstrap.css" rel="stylesheet">
	<link href="<?php echo TEMPLATE_URL; ?>css/main.css" rel="stylesheet"> 
  </head>
  <body>

    <div class="container">

      <div class="masthead">
        <a id="logo" title="Волга-ИТ" href="">Волга-ИТ</a>
        <div class="navbar">
          <div class="navbar-inner">
            <div class="container">
              <ul class="nav">
                <li><a href="">Главная</a></li>
                <li><a href="index.php?/csv/">Редактирование CSV</a></li>
              </ul>
            </div>
          </div>
        </div><!-- /.navbar -->
      </div>

      <div class="row-fluid">
        <div class="span12">
			<h2><?php echo $title; ?></h2>
			<?php echo $content; ?>
        </div>
	  </div>
	  
      <hr>

      <div class="footer">
        <p>&copy; Igor Evstegneev</p>
      </div>

    </div> <!-- /container -->

    <!-- Le javascript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="<?php echo TEMPLATE_URL; ?>js/jquery-1.9.1.js"></script>
	<script src="<?php echo TEMPLATE_URL; ?>js/bootstrap.js"></script>
  </body>
</html>